#include "cat.h"


sdg_ht* lire_fichier_codes (char *nom_fichier, int* nb_cat) {
  FILE* fic;
  char c;
  char *mot;
  int taille = 0;
  unsigned int code = -1;
  int *p_compt;
  sdg_ht *table;

  /* Ouverture du fichier */
  if ((fic=fopen(nom_fichier,"r")) == NULL) {
    printf("Imposible d'ouvrir %s\n",nom_fichier);
    perror("fopen");
    exit (-1);
  }
  /* Creation de la table de hachage */
  table = sdg_ht_cree(TAILLE_CAT_HT);
  /* Lecture du fichier */
  mot = malloc(TAILLE_MAX_CAT*sizeof(char));
  if ((c=(char)fgetc(fic)) == EOF) {
    return table;
  }
  taille ++;
  mot[0] = c;
  while (c != EOF) {
    if (c=='\n') {
      /* Insertion du mot ds la table de hachage */
      if (taille != 1) { /* Le mot n'est pas vide */
        code ++;
        p_compt = malloc(sizeof(int));
        *p_compt = code;
        mot[taille-1] = '\0';
        mot = realloc(mot,taille);
        sdg_ht_insere(table,mot,p_compt);
      }
      /* Reinit pour lire le mot suivant */
      taille = 0;
      mot = malloc(TAILLE_MAX_CAT*sizeof(char));
    }
    c = (char)fgetc(fic);
    taille ++;
    mot[taille-1] = c;
  }

  fclose(fic);
  free(mot);

  *nb_cat = code+1;
  return table;
}

char** sdg_ht_allcat(sdg_ht *cat_ht, int nb_cat) {
  int i,j;
  int code;
  char** cat;
  sdg_lcn *pm;

  cat = malloc(nb_cat*sizeof(char*));
  /* Parcours de la ht */
  for(i=0; i<cat_ht->taille; i++) {
    for(pm=cat_ht->tab[i] ; pm ; pm=pm->suiv) {
      code = *((int*)pm->val);
      cat[code] = pm->clef;
    }
  }
  return cat;
}
