#include "cat.h"
#include "dico.h"
#include "bigram.h"
#include "viterbi.h"
#include "divers.h"
#include <stdlib.h>

int main (int argc, char **argv) {
  double prob;
  int *p_test;
  int i,compt;
  sdg_ht *cat_ht, *dico_ht;
  double **bigram,**bigram_lisse;
  int nb_cat;
  FILE *fic_in,*fic_out,*fic_out2,*fic_out3;
  char *mot,**phrase;
  int taille;
  int *meilleur_chemin,*meilleur_chemin_lisse;
  int best;
  char *categorie;
  char **tab_cat;
  int fin=0;
  int palier,progression;
  long total;
  double alpha,beta;

  /** Creation de la table de hachage des categories (cat.c) */
  cat_ht = lire_fichier_codes("../data2/lmp7-1.tagset",&nb_cat);
  /* Cration du tableau num_cat -> nom_cat */
  tab_cat = sdg_ht_allcat(cat_ht,nb_cat);
  /* test... */
  printf("----------------------------------------------------------\n");
  printf("Creation des categorie (cat.c)\n");
  p_test = malloc(sizeof(int));
  printf("*Toutes les categories\n");
  sdg_ht_affiche_clefs(cat_ht);
  printf("\n*Nombre de categories\n");
  printf("%i\n",nb_cat);
  printf("\n*Quelques numeros de categorie d'apres le nom de la categorie\n");
  p_test = (int*) sdg_ht_recherche(cat_ht,"V--P1s");
  printf("V--P1s=%i\n",*p_test);
  p_test = (int*) sdg_ht_recherche(cat_ht,"ADV");
  printf("ADV=%i\n",*p_test);
  p_test = (int*) sdg_ht_recherche(cat_ht,"P");
  printf("P=%i\n",*p_test);
  printf("*Les categories d'apres leur numero");
  for (i=0 ; i<nb_cat ; i++) {
    if (i%6 == 0)
      printf("\n");
    printf("(%3i:%14s) ",i,tab_cat[i]);
  }

  /** Creation de la table de hachage des mots (table d'mission) */
  dico_ht = charge_dico("../data2/lmp7-1.dico", cat_ht, nb_cat);
  /* test... */
  printf("\n----------------------------------------------------------\n");
  printf("Calcul de la table d'emission (dico.c)\n");
  // sdg_ht_affiche_clefs(dico_ht);
  printf("*Av calcul (calcule_proba_dico) : C('le',cat) (nb de 'the' par categorie)");
  for (i=0 ; i<nb_cat ; i++) {
    if (i%5 == 0)
      printf("\n");
    prob = proba_mot_cat(dico_ht,"le",i);
    if (prob == 0)
      printf("(cat %3i:     0) ",i, prob);
    else
      printf("(cat %3i:%6.0f) ",i, prob);
  }
  printf("\n");
  calcule_proba_dico(dico_ht,nb_cat);
  printf("\n*Ap calcul (calcule_proba_dico): p('le'|cat)=C('the',cat)/C(cat)");
  for (i=0 ; i<nb_cat ; i++) {
    if (i%5 == 0)
      printf("\n");
    prob = proba_mot_cat(dico_ht,"le",i);
    if (prob == 0)
      printf("(cat %3i:     0) ",i, prob);
    else
      printf("(cat %3i:%.4f) ",i, prob);
  }
  printf("\n");

  /** Creation de la table des transitions */
  bigram = charge_bigram("../data2/lmp7-1.train.2g",cat_ht,nb_cat);
  bigram_lisse = charge_bigram("../data2/lmp7-1.train.2g",cat_ht,nb_cat);
  /* Test */
  printf("----------------------------------------------------------\n");
  printf("Calcul de la table des transitions (bigram.c)\n");
  compt = 0;
  printf("*Av calcul proba (calcule_proba_bigram) : C(1,c) ");
  printf("(nb de fois qu'un mot de cat 1\n est suivi d'un mot de cat c)");
  for (i=0 ; i<nb_cat ; i++) {
    compt += bigram[1][i];
    if (i%7 == 0)
      printf("\n");
    printf("(1-%3i=%4.0f) ",i,bigram[1][i]);
  }
  printf("\n*Nb de fois qu'un mot etiquete par 1 est suivi d'un ");
  printf("autre mot : C(1)\n");
  printf("C(1)=%i\n",compt);
  calcule_proba_bigram(bigram,nb_cat); // Calcul de T(i,j)
  printf("*Ap calcul proba : p(c|1)=C(1,c)/C(1)");
  for (i=0 ; i<nb_cat ; i++) {
    if (i%6 == 0)
      printf("\n");
    if (bigram[1][i] == 0)
      printf("(1-%3i=     0) ",i);
    else
      printf("(1-%3i=%.4f) ",i,bigram[1][i]);
  }
  calcule_proba_bigram_lisse(bigram_lisse,nb_cat); // Lissage de T(i,j)

  //printf("----------------------------------------------------------\n");
  //affiche_tables(dico_ht,bigram_lisse,2,nb_cat);
  //affiche_tables(dico_ht,bigram,2,nb_cat);

  /*** Etiquetage du fichier test */
  printf("\n----------------------------------------------------------\n");
  /** Initialisation ... */
  /* Init phrase */
  phrase = malloc(TAILLE_MAX_PHRASE*sizeof(char*));
  /* Ouverture du fichier  de test */
  if ((fic_in=fopen("../data2/lmp7-1.test.mots","r")) == NULL) {
    printf("Imposible d'ouvrir le fichier test\n");
    perror("fopen");
    exit (-1);
  }
  /* Ouverture du fichier resultat de l'tiquetage */
  if ((fic_out=fopen("../data2/result_etiquetage","w")) == NULL) {
    printf("Imposible d'ouvrir le fichier resultat\n");
    perror("fopen");
    exit (-1);
  }
  /* Ouverture du fichier calculant la proba des phrases */
  if ((fic_out2=fopen("../data2/result_proba_phrases","w")) == NULL) {
    printf("Imposible d'ouvrir le fichier proba des phrases\n");
    perror("fopen");
    exit (-1);
  }
  /* Ouverture du fichier resultat de l'tiquetage avec lissage de T(i,j) */
  if ((fic_out3=fopen("../data2/result_etiquetage2","w")) == NULL) {
    printf("Imposible d'ouvrir le fichier resultat2\n");
    perror("fopen");
    exit (-1);
  }
  /** Lecture du fichier test et ecriture du resultat phrase par phrase */
  /* Prparation de la barre de progression */
  printf("Etiquetage du fichier ../data/test (resultat ds ../data/test_etiquete)\n");
  printf("Calculs de proba de phrase (resultat ds ../data/test_proba_phrases)");
  printf("\n|0%c                                          100%c|\n",'%','%');
  printf("|");
  fflush(stdout);
  palier = 0;
  progression = 0;
  fseek(fic_in,0,SEEK_END);
  total = ftell(fic_in);
  fseek(fic_in,0,SEEK_SET);
  /* Boucle d'tiquetage */
  while (1) {
    /* Lecture d'une phrase */
    taille = 0;
    do {
      mot = malloc(TAILLE_MAX_MOT*sizeof(char));
      if (fscanf(fic_in,"%s\n",mot) == EOF) {
        // La fin du fichier  tiqueter est atteinte -> fin
        fclose(fic_in);
        fclose(fic_out);
        fclose(fic_out2);
        free(phrase);
        free(meilleur_chemin);
        free(meilleur_chemin_lisse);
        free(p_test);
        printf("\n");
        return 0;
      }
      taille ++;
      phrase[taille-1] = mot;
      progression += strlen(mot)+1;
    } while (strcmp(mot,"</s>") != 0);
    /* Etiqueter la phrase */
    meilleur_chemin = viterbi(dico_ht,bigram,phrase,taille,nb_cat);
    meilleur_chemin_lisse = viterbi(dico_ht,bigram_lisse,phrase,taille,nb_cat);
    for (i=0 ; i<taille ; i++) {
      // Etiquetage avec T(i,j) normale
      best = meilleur_chemin[i];
      categorie = tab_cat[best];
      fprintf(fic_out,"%s %s\n",phrase[i],categorie);
      // Etiquetage avec T(i,j) liss
      best = meilleur_chemin_lisse[i];
      categorie = tab_cat[best];
      fprintf(fic_out3,"%s %s\n",phrase[i],categorie);
    }
    /* Calcul de la proba de qq phrases */
    if (palier < 5) {
      fprintf(fic_out2,"---------------------------------------------\n");
      /// Calcul de la proba d'une phrase normale
      fprintf(fic_out2,"Calcul de la proba d'une phrase normale\n");
      // Impression de la phrase
      for (i=0 ; i<taille ; i++) {
        fprintf(fic_out2," %s",phrase[i]);
      }
      // Calcul des proba
      alpha = proba_alpha(dico_ht,bigram,phrase,taille,nb_cat);
      beta = proba_beta(dico_ht,bigram,phrase,taille,nb_cat);
      fprintf(fic_out2,"\n=>proba_alpha=%e proba_beta=%e\n",alpha,beta);
      fprintf(fic_out2,"---------------\n");
      /// Calcul de la proba de phrases ne commencant pas par <s>
      fprintf(fic_out2,"Calcul de la proba d'une phrase ne commencant pas par <s>\n");
      // Impression de la phrase
      free(phrase[0]);
      phrase[0] = strdup("the");
      for (i=0 ; i<taille ; i++) {
        fprintf(fic_out2," %s",phrase[i]);
      }
      // Calcul des proba
      alpha = proba_alpha(dico_ht,bigram,phrase,taille,nb_cat);
      beta = proba_beta(dico_ht,bigram,phrase,taille,nb_cat);
      fprintf(fic_out2,"\n=>proba_alpha=%e proba_beta=%e\n",alpha,beta);
      fprintf(fic_out2,"---------------\n");
      /// Calcul de la proba d'une phrase contenant un mot inconnu
      fprintf(fic_out2,"Calcul de la proba d'une phrase contenant un mot inconnu\n");
      // Impression de la phrase
      free(phrase[0]);
      phrase[0] = strdup("<s>");
      free(phrase[1]);
      phrase[1] = strdup("uluberlu");
      for (i=0 ; i<taille ; i++) {
        fprintf(fic_out2," %s",phrase[i]);
      }
      // Calcul des proba
      alpha = proba_alpha(dico_ht,bigram,phrase,taille,nb_cat);
      beta = proba_beta(dico_ht,bigram,phrase,taille,nb_cat);
      fprintf(fic_out2,"\n=>proba_alpha=%e proba_beta=%e\n",alpha,beta);
      fprintf(fic_out2,"---------------------------------------------\n\n");
    }
    /* Affichage de la progression */
    if (total > 0) {
      while (palier+2 < (int)(progression*100/total)) {
        palier += 2;
        printf("|");
        fflush(stdout);
      }
    }
    /* Liberation de la memoire */
    for (i=0 ; i<taille ; i++) {
      free(phrase[i]);
    }
    free(meilleur_chemin);
  }
  printf("\n");
  return 0;
}
