#include "baum_welsh.h"

void calcule_alpha(double** alpha, sdg_ht* ht_emis, double **t_trans, double *pi, char **texte, int taille, int nb_cat) {
  int i,j,t;
  // Init
  for (i=0 ; i<nb_cat ; i++) {
    alpha[0][i] = pi[i];
  }
  // Récursion
  for (t=1 ; t<taille ; t++) {
    for (j=0 ; j<nb_cat ; j++) {
      alpha[t][j] = 0;
      for (i=0 ; i<nb_cat ; i++) {
        alpha[t][j] += alpha[t-1][i]*proba_mot_cat(ht_emis,texte[t-1],i)*proba_cat_cat(t_trans,i,j);
	//printf("[alpha(%i,%i)=%f (%s,%f) (%i-%i:%f)]",j,t,alpha[t][j],texte[t-1],proba_mot_cat(ht_emis,texte[t-1],i),i,j,proba_cat_cat(t_trans,i,j));
      }
    }
  }
}

void calcule_beta(double** beta, sdg_ht* ht_emis, double **t_trans, char **texte, int taille, int nb_cat) {
  int i,j,t;
  //Init
  for (i=0 ; i<nb_cat ; i++) {
    beta[taille-1][i] = proba_mot_cat(ht_emis, texte[taille-1], i);
    printf("beta(%i,%i)=%f ",taille-1,i,proba_mot_cat(ht_emis, texte[taille-1], i));
  }
  printf("\n");
  // Récursion
  for (t=taille-2 ; t>=0 ; t--) {
    for (i=0 ; i<nb_cat ; i++) {
      beta[t][i] = 0;
      for (j=0 ; j<nb_cat ; j++) {
        beta[t][i] += beta[t+1][j]*proba_mot_cat(ht_emis, texte[t], i)*proba_cat_cat(t_trans,i,j);
      }
      printf("beta(%i,%i)=%f ",i,t);
    }
  }
}

void calcule_gamma(double** gamma, double **alpha, double **beta, int taille, int nb_cat) {
  int i,j,t;
  double sigma;

  for (t=0 ; t<taille ; t++) {
    for (i=0 ; i<nb_cat ; i++) {
      sigma = 0;
      for (j=0 ; j<nb_cat ; j++) {
	sigma += alpha[t][j]*beta[t][j];
      }
      gamma[t][i] = (alpha[t][i]*beta[t][i])/sigma;
      //printf("gamma(%i,%i)=%d|",i,t,gamma[t][i]);
    }
  }
}

void calcule_ro(double*** ro, sdg_ht* ht_emis, double **t_trans, double **alpha, double **beta, char **texte, int taille, int nb_cat) {
  int i,j,k,t;
  double sigma;
  for (t=0 ; t<taille-1 ; t++) {
    for (i=0 ; i<nb_cat ; i++) {
      for (j=0 ; j<nb_cat ; j++) {
	sigma = 0;
	for (k=0 ; k<nb_cat ; k++) {
	  sigma += alpha[t][j]*beta[t][j];
	}
	ro[t][i][j] = (alpha[t][i]*proba_mot_cat(ht_emis,texte[t],i)*proba_cat_cat(t_trans,i,j)*beta[t+1][j])/sigma;
      }
    }
  }
}

void new_pi(double* pi, double **gamma, int nb_cat) {
  int i;
  for (i=0 ; i<nb_cat ; i++) {
    pi[i] = gamma[0][i];
  }
}

void new_emis(sdg_ht *ht_emis, double **gamma, char **texte, int taille, int nb_cat) {
  int i,j,k,t;
  double sigma1,sigma2;
  sdg_lcn *pm;
  for(k=0; k<ht_emis->taille; k++) {
    for(pm=ht_emis->tab[k]; pm; pm=pm->suiv) {
      // Pour tous les mots
      for (i=0 ; i<nb_cat ; i++) {
	sigma1=0;
	for (t=0 ; t<taille ; t++) {
	  if (strcmp(pm->clef,texte[t]) == 0) {
	    sigma1 += gamma[t][i];
	  }
	}
	sigma2 = 0;
	for (t=0 ; t<taille ; t++) {
	  sigma2 += gamma[t][i];
	  printf("(%i,%i)|",i,t);
	}
	((double*)pm->val)[i] = sigma1/sigma2;
	//printf("Emis(%s,%i)=%f\n",pm->clef,i,sigma1/sigma2);
	fflush(stdout);
      }
    }
  }
}

void new_trans(double ** t_trans, double **gamma,double ***ro, char **texte, int taille, int nb_cat) {
  int i,j,t;
  double sigma1,sigma2;
  for (i=0 ; i<nb_cat ; i++) {
    for (j=0 ; j<nb_cat ; j++) {
      sigma1 = 0;
      for (t=0 ; t<taille ; t++) {
	sigma1 += ro[t][i][j];
      }
      sigma2 = 0;
      for (t=0 ; t<taille ; t++) {
	sigma2 += gamma[t][i];
      }
      t_trans[i][j] = sigma1/sigma2;
    }
  }
}
